SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:15'!
initialize 
	"comment stating purpose of message"

	|myBase|
	
	myBase := BaseStackElement new.
	list := OrderedCollection new.
	list add: myBase.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:17'!
isEmpty
	
	^ (list size == 1).! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:06'!
pop

	|top|
	
	top := list last.
	
	^ top areYouTheBaseOfMePop: list.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 20:17'!
push: anObject
	"comment stating purpose of message"
	
	| aStackElement |
	
	aStackElement := NoBaseStackElement new.
	aStackElement wrapElement: anObject.
	list add: aStackElement.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:19'!
size
	
	  ^list size - 1.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:07'!
top

	|top|
	
	top := list last.
	
	^ top areYouTheBaseOfMeTop: list.! !

Object subclass: #StackElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

StackElement subclass: #BaseStackElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!BaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:10'!
areYouTheBaseOfMePop: anOrderedCollection.

	^ self error: 'Stack is empty'.! !

!BaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:10'!
areYouTheBaseOfMeTop: anOrderedCollection.

	^ self error: 'Stack is empty'.! !

StackElement subclass: #NoBaseStackElement
	instanceVariableNames: 'aWrappedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!NoBaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:05'!
areYouTheBaseOfMePop: anOrderedCollection
	
	|objectToReturn top|
	
	top := anOrderedCollection last.
	
	objectToReturn := top unWrapElement.
	
	anOrderedCollection removeLast.
	
	^ objectToReturn.
	
	 ! !

!NoBaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:05'!
areYouTheBaseOfMeTop: anOrderedCollection
	
	|objectToReturn top|
	
	top := anOrderedCollection last.
	
	objectToReturn := top unWrapElement.
	
	
	^ objectToReturn.
	
	 ! !

!NoBaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 20:49'!
unWrapElement

	^ aWrappedObject.
	! !

!NoBaseStackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 20:25'!
wrapElement: anObject
	"comment stating purpose of message"

	aWrappedObject := anObject.! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:13'!
areYouTheBaseOfMePop: anOrderedCollection.

	 self subclassResponsibility. ! !

!StackElement methodsFor: 'as yet unclassified' stamp: 'FromerMaffongelli 5/14/2012 21:13'!
areYouTheBaseOfMeTop: anOrderedCollection.

	 self subclassResponsibility. ! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:39'!
test09CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
